#!/usr/bin/padawan

# Print HTTP headers, so that the browser knows what to do with the results

print "Content-Type:text/html;charset=utf8"
print 

# Print out those parameters, just so that we could see what's happening
print "<pre>"
print "<b>The parameters provided by the user:</b>"
print

print_form()


# We'll want to link each character's info page.
# We'll use the following template to format the link.
# Note that the template contains "%s" twice. The first will
# be filled with the id, the second one with the name. 

persona_link_template = """
<a href="/~okenobi/dynamic/show_persona_info.py?id=%s">%s</a>
"""


# Connect to the database

connect_to_db("starwars", "okenobi")

# Setup the query template
query_template = """
select * from persona
where species = '%s' and gender = '%s';
"""

# Print it out, so that we know what's going on
print "<b>The query template:</b>"
print query_template

# Check if the necessary fields are provided
if form_has_field("species") and form_has_field("gender"):

    # Yes, the user provided values for both parameters!

    # Get the value for 'species' parameter from the form
    species = get_form_field_value("species")
    # Escape it to avoid mischief
    species = escape_string(species)
    # Get the value for 'gender' parameter from the form
    gender = get_form_field_value("gender")
    # Escape it to avoid mischief
    gender = escape_string(gender)

    # Fill in the query with the values supplied by the user  
    query = fill_template(query_template, species, gender)

    # Print out the filled-in query so that we know what's going on
    print "<b>The filled-in query:</b>"
    print query
    print "</pre>"

    # Now we can actually send the query to the database
    print "<h1>The results of the query</h1>"

    # Tell the cursor to run the query
    execute_query(query);

    # Check if the query yielded any rows

    if get_row_count() > 0 :

        # Yes, we've got results!

        print "<p>We have ", get_row_count(), " matching rows!</p>"

        # Start the html table
        print "<table border='1'>"
        # For each row in the list...
        for row in fetch_all_rows():
            # Start an HMTL row
            print "<tr>"
            print "<td>"
            id = get_row_value(row, "id")
            name = get_row_value(row, "name")
            print fill_template(persona_link_template, id, name)
            print "<td>", get_row_value(row, "species"), "</td>"
            print "<td>", get_row_value(row, "gender"), "</td>"
            print "</tr>"
            # close the HTML row tag and move on to the next row
        print "</table>"
        # done!

    else :
        # No, the query did not return any rows
        print "No match!"
  
else :
    # No, the user did not provide all the parameters
    print "Some of the necessary parameters are not set"
