#!/usr/bin/padawan

# Print HTTP headers, so that the browser knows what to do with the results

print "Content-Type:text/html;charset=utf8"
print 

# Print out those parameters, just so that we could see what's happening
print "<pre>"
print "<b>The parameters provided by the user:</b>"
print

print_form()

# Connect to the database

connect_to_db("starwars", "okenobi")

# Setup the query template (this time with a join)
query_template = """
select
 persona.name as name,
 persona.size as size,
 persona.species as species,
 persona.occupation as occupation,
 world.population as world_population
from persona
join world
on persona.homeworld=world.world_name
where persona.id = '%s';
"""

# Print it out, so that we know what's going on
print "<b>The query template:</b>"
print query_template

# Check if the necessary fields are provided
if form_has_field("id") :

    # Yes, the user provided values for both parameters!

    # Get the value for 'id' parameter from the form
    id = get_form_field_value("id")
    # Escape it to avoid mischief
    id = escape_string(id)

    # Fill in the query with the values supplied by the user  
    query = fill_template(query_template, id)

    # Print out the filled-in query so that we know what's going on
    print "<b>The filled-in query:</b>"
    print query
    print "</pre>"

    # Tell the cursor to run the query
    execute_query(query);

    # Check if the query yielded any rows

    if get_row_count() > 0 :

        # Yes, we've got results!

        print "<p>We have ", get_row_count(), " matching rows!</p>"

        # Start the html table
        # For each row in the list... (We really shouldn't have more than one.)
        for row in fetch_all_rows():
            # Start an HMTL row
            print "<h1>", get_row_value(row, "name"), "</h1>"

            print "<b>species</b>:", get_row_value(row, "species"), "<br/>"
            print "<b>size</b>:", get_row_value(row, "size"), "m. (approx) <br/>"
            print "<b>occupation</b>:", get_row_value(row, "occupation"), "<br/>"
            print "<b>species</b>:", get_row_value(row, "species"), "<br/>"
            print "<b>homeworld population</b>:", get_row_value(row, "world_population"), "<br/>"

        # done!

    else :
        # No, the query did not return any rows
        print "No match!"
  
else :
    # No, the user did not provide all the parameters
    print "Some of the necessary parameters are not set"
